﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Input;
using Telerik.Windows.Controls;
using System.Windows;
using System.Diagnostics;

namespace RadGridView_WPF_NoXAML_91
{
    public class MyViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        private ObservableCollection<Club> clubs;

        private ICommand validateCommand;
        private ICommand saveCommand;

        public ICommand SaveCommand
        {
            get { return saveCommand; }
            set { saveCommand = value; }
        }
        

        public ICommand ValidateCommand
        {
            get { return validateCommand; }
            set { validateCommand = value; }
        }
        

        public MyViewModel()
        {
            this.ValidateCommand = new DelegateCommand(OnCustomCommandExecuted);
            this.SaveCommand = new DelegateCommand(OnSaveCommandExecuted);
        }

        private void OnSaveCommandExecuted(object obj)
        {
            (obj as GridViewRowEditEndedEventArgs).UserDefinedErrors.Clear();
        }


        private void OnCustomCommandExecuted(object obj)
        {
            var club = (obj as GridViewRowValidatingEventArgs).Row.DataContext as Club;
            if (club.StadiumCapacity < 50000)
            {
                var validationResult = new GridViewCellValidationResult
                {
                    PropertyName="StadiumCapacity",
                    ErrorMessage = "Club capacity must be over 50000"
                };
                (obj as GridViewRowValidatingEventArgs).ValidationResults.Add(validationResult);
            }

            if ((obj as GridViewRowValidatingEventArgs).ValidationResults.Count > 0   )
            {
                (obj as GridViewRowValidatingEventArgs).IsValid = false;
            }
        }

    
        public ObservableCollection<Club> Clubs
        {
            get
            {
                if (this.clubs == null)
                {
                    this.clubs = Club.GetClubs();
                }

                return this.clubs;
            }
        }

       
        protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, args);
            }
        }

        private void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
    }
}
